## gdm3 49~alpha.1

=== debian/changelog ===
gdm3 (49~alpha.1-0ubuntu1) questing; urgency=medium

  * New upstream release

 -- Alessandro Astone <alessandro.astone@canonical.com>  Mon, 07 Jul 2025 10:35:17 +0200

gdm3 (49~alpha.0-0ubuntu1) questing; urgency=medium

  * New upstream release
  * debian/patches: Delete Drop-Nvidia-power-management-suspend-checks.patch
  * debian/patches: Refresh patches
  * debian: Disable x11 greeter

 -- Alessandro Astone <alessandro.astone@canonical.com>  Wed, 18 Jun 2025 13:48:00 +0200

gdm3 (48.0-1ubuntu1) plucky; urgency=medium

  * Merge with Debian. Remaining changes:
    + readme.debian: update for correct paths in ubuntu
    + control:
      - don't recommend desktop-base
      - depend on bash for config_error_dialog.patch
      - update vcs field
    + rules:
      - don't override default user/group
      - -dgdm-xsession=true to install upstream xsession script
      - override dh_installinit with --no-start to avoid session being killed
    + rules, readme.debian, gdm3.8.pod:
      use upstream custom.conf instead of daemon.conf
    + gdm3.{postinst,postrm}: rename user and group back to gdm
    + debian/tests/control:
      - Use gdm user name
    + gdm3.*.pam: make pam_env read ~/.pam_environment, as we use in g-c-c
      settings
    + gdm3.install:
      - don't install debian/xsession
    + add run_xsession.d.patch
    + add xresources_is_a_dir.patch
      - fix loading from /etc/x11/xresources/*
    + add nvidia_prime.patch:
      - add hook to run prime-offload (as root) and prime-switch if
        nvidia-prime is installed
    + add revert_override_lang_with_accountservices.patch:
      - on ubuntu accountservices only stores the language and not the
        full locale as needed by lang.
    + add dont_set_language_env.patch:
      - don't run the set_up_session_language() function, since it
        overrides variable values set by ~/.pam_environment
    + add config_error_dialog.patch:
      - show warning dialog in case of error in ~/.profile etc. and
        don't let a syntax error make the login fail
    + add prefer_ubuntu_session_fallback.patch:
      - Prefer ubuntu session as fallback instead of GNOME
    + add XSession-Use-x-terminal-emulator-as-fallback-instead-of-x.patch:
      - Use x-terminal-emulator as fallback instead of xterm
    + add Drop-Nvidia-power-management-suspend-checks.patch:
      - Ensure Nvidia drivers always get Wayland as the default, despite
        known issues with suspend/resume affecting Wayland more than Xorg.
    + add debian/default.pa
      - disable bluetooth audio devices in pulseaudio from gdm3.
    + debian/gdm3.install
      - added details of the default.pa file
    + debian/gdm3.postinst
      - added installation of default.pa and creation of dir if it doesn't
        exist.
    + debian/greeter.dconf-defaults: don't set debian settings in the
      greeter's dconf db

 -- Jeremy Bícha <jbicha@ubuntu.com>  Mon, 17 Mar 2025 12:37:38 -0400

=== debian/control ===
Source: gdm3
Section: gnome
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian GNOME Maintainers <pkg-gnome-maintainers@lists.alioth.debian.org>
Uploaders: Jeremy Bicha <jbicha@ubuntu.com>, Marco Trevisan (Treviño) <marco@ubuntu.com>
Build-Depends: check (>= 0.9.4),
               dconf-cli (>= 0.19.90),
               debhelper-compat (= 13),
               dh-exec,
               dh-sequence-gir,
               dh-sequence-gnome,
               docbook-xml,
               gettext (>= 0.19.8),
               gjs [amd64 arm64 armhf i386 loong64 mips64el mipsel ppc64el s390x riscv64],
               gnome-pkg-tools (>= 0.16.3),
               gnome-settings-daemon-dev (>= 3.24.0),
               gobject-introspection (>= 0.10.7-1~),
               intltool,
               iso-codes,
               itstool,
               libaccountsservice-dev (>= 0.6.35),
               libaudit-dev [linux-any],
               libgirepository1.0-dev (>= 0.9.12),
               libglib2.0-dev (>= 2.44.0),
               libgudev-1.0-dev (>= 232),
               libjson-glib-dev,
               libkeyutils-dev [linux-any],
               libpam0g-dev,
               libplymouth-dev [linux-any],
               libselinux1-dev [linux-any],
               libsystemd-dev [linux-any],
               meson (>= 0.57),
               pkgconf,
               systemd-dev,
Standards-Version: 4.7.0
XS-Debian-Vcs-Git: https://salsa.debian.org/gnome-team/gdm.git
XS-Debian-Vcs-Browser: https://salsa.debian.org/gnome-team/gdm
Vcs-Git: https://salsa.debian.org/gnome-team/gdm.git -b ubuntu/latest
Vcs-Browser: https://salsa.debian.org/gnome-team/gdm/tree/ubuntu/latest
Rules-Requires-Root: no
Homepage: https://wiki.gnome.org/Projects/GDM/

Package: gdm3
Architecture: amd64 arm64 armhf i386 loong64 mips64el mipsel ppc64el s390x riscv64
Depends: accountsservice (>= 0.6.35),
         adduser,
         bash (>= 4.3),
         dconf-cli (>= 0.20),
         dconf-gsettings-backend (>= 0.20),
         dbus-bin | systemd-sysv,
         dbus-daemon,
         default-dbus-system-bus | dbus-system-bus,
         default-logind [linux-any] | logind [linux-any],
         gir1.2-gdm-1.0 (= ${binary:Version}),
         ubuntu-session | gnome-session | x-session-manager | x-window-manager | x-terminal-emulator,
         gnome-session-bin (>= 3.37.0),
         gnome-session-common (>= 3.37.0-2~),
         gnome-settings-daemon (>= 3.37.0),
         gnome-shell (>= 3.37.90),
         gsettings-desktop-schemas,
         libgdm1 (= ${binary:Version}),
         libglib2.0-bin (>= 2.35.0),
         libpam-modules (>= 0.72-1),
         libpam-runtime (>= 0.76-13.1),
         librsvg2-common,
         polkitd [linux-any],
         procps,
         ucf,
         x11-common (>= 1:7.6+11),
         x11-xserver-utils,
         ${misc:Depends},
         ${shlibs:Depends}
Recommends: at-spi2-core,
            ubuntu-session | gnome-session | x-session-manager,
            x11-xkb-utils,
            xserver-xephyr,
            xserver-xorg,
            zenity
Suggests: orca,
          libpam-fprintd (>= 0.8.0-2),
          libpam-sss (>= 2.3.0-1),
          libpam-pkcs11,
          libpam-gnome-keyring
Provides: x-display-manager
Description: GNOME Display Manager
 GDM provides the equivalent of a "login:" prompt for X displays: it
 asks for a login and starts graphical sessions.
 .
 It supports multiple seats and switching between multiple users.
 .
 The greeter is based on the GNOME libraries and applications, and its
 look and design are the same as those of a GNOME session.

Package: libgdm1
Section: libs
Architecture: linux-any
Depends: ${gir:Depends},
         ${misc:Depends},
         ${shlibs:Depends}
Description: GNOME Display Manager (shared library)
 GDM provides the equivalent of a "login:" prompt for X displays: it
 asks for a login and starts graphical sessions.
 .
 It supports multiple seats and switching between multiple users.
 .
 The greeter is based on the GNOME libraries and applications, and its
 look and design are the same as those of a GNOME session.
 .
 This package contains the shared library required by gnome-shell.

Package: libgdm-dev
Section: libdevel
Architecture: linux-any
Depends: gir1.2-gdm-1.0 (= ${binary:Version}),
         libgdm1 (= ${binary:Version}),
         libglib2.0-dev (>= 2.44.0),
         ${gir:Depends},
         ${misc:Depends},
         ${shlibs:Depends}
Provides: ${gir:Provides}
Description: GNOME Display Manager (development files)
 GDM provides the equivalent of a "login:" prompt for X displays: it
 asks for a login and starts graphical sessions.
 .
 It supports multiple seats and switching between multiple users.
 .
 The greeter is based on the GNOME libraries and applications, and its
 look and design are the same as those of a GNOME session.
 .
 This package contains header and development files.

Package: gir1.2-gdm-1.0
Section: introspection
Architecture: linux-any
Depends: ${gir:Depends},
         ${misc:Depends},
         ${shlibs:Depends}
Conflicts: gir1.2-gdm3
Replaces: gir1.2-gdm3
Description: GObject introspection data for the GNOME Display Manager
 GDM provides the equivalent of a "login:" prompt for X displays: it
 asks for a login and starts graphical sessions.
 .
 It supports multiple seats and switching between multiple users.
 .
 The greeter is based on the GNOME libraries and applications, and its
 look and design are the same as those of a GNOME session.
 .
 This package contains introspection data for the GNOME Display Manager.

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/architecture.mk
include /usr/share/dpkg/buildflags.mk
include /usr/share/dpkg/pkg-info.mk
include /usr/share/gnome-pkg-tools/1/rules/gnome-version.mk

built_binaries := $(shell dh_listpackages)

export systemdsystemunitdir = $(shell pkgconf --variable=systemdsystemunitdir systemd | sed s,^/,,)
export udevdir = $(shell pkgconf --variable=udevdir udev | sed s,^/,,)

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
export DEB_LDFLAGS_MAINT_APPEND = -Wl,-z,defs

ifeq (linux,$(DEB_HOST_ARCH_OS))
CONFFLAGS += \
	-Dselinux=enabled \
	-Dplymouth=enabled
else
CONFFLAGS += \
	-Dwayland-support=false \
	-Dselinux=disabled
endif

ifneq (,$(filter debug,$(DEB_BUILD_OPTIONS)))
CONFFLAGS += --buildtype=debug
endif

pod2man := pod2man --release="GNOME $(DEB_GNOME_VERSION)" --center="Debian GNU/Linux"
PODFILES := $(wildcard debian/*.pod)
MANPAGES := $(patsubst %.pod,%,$(PODFILES))

debian/%: debian/%.pod
	$(pod2man) --section=$(shell echo $@ | sed 's/.*\.//') \
		$< | sed -e 's/debian:://' >$@

%:
	dh $@

# We set this up manually
override_dh_installsystemd:

override_dh_auto_configure:
	X_BIN="/usr/bin/Xorg" \
	dh_auto_configure -- \
		-Ddistro=debian \
		-Dipv6=true \
		-Dat-spi-registryd-dir=/usr/lib/at-spi \
		-Ddefault-path=/usr/local/bin:/usr/bin:/bin:/usr/games \
		-Dsysconfsubdir=gdm3 \
		-Dworking-dir=/var/lib/gdm3 \
		-Dxauth-dir=/run/gdm3 \
		-Drun-dir=/run/gdm3 \
		-Dpid-file=/run/gdm3.pid \
		-Dlog-dir=/var/log/gdm3 \
		-Dgdm-xsession=true \
		-Dpam-mod-dir=/usr/lib/$(DEB_HOST_MULTIARCH)/security \
		-Dscreenshot-dir=/run/gdm3/greeter \
		-Ddefaults-conf=/usr/share/gdm/defaults.conf \
		-Dlang-file=/etc/default/locale \
		-Dran-once-marker-dir=/run/gdm3 \
		-Dgnome-settings-daemon-dir="`pkg-config --variable=libexecdir gnome-settings-daemon`" \
		-Dx11-support=false \
		$(CONFFLAGS)

override_dh_auto_build: $(OUTFILES) $(MANPAGES)
	dh_auto_build

override_dh_install:
	dh_install
ifneq ($(filter gdm3,$(built_binaries)),)
	mv debian/gdm3/usr/sbin/gdm debian/gdm3/usr/sbin/gdm3
#	chmod 755 debian/gdm3/etc/gdm3/Xsession
	chmod 755 debian/gdm3/usr/share/gdm/generate-config
	dh_installpam -pgdm3 --name=gdm-autologin
	dh_installpam -pgdm3 --name=gdm-launch-environment
	dh_installpam -pgdm3 --name=gdm-password
	dh_installpam -pgdm3 --name=gdm-fingerprint
	dh_installpam -pgdm3 --name=gdm-smartcard-sssd-exclusive
	dh_installpam -pgdm3 --name=gdm-smartcard-sssd-or-password
	dh_installpam -pgdm3 --name=gdm-smartcard-pkcs11-exclusive
endif

override_dh_missing:
	dh_missing --fail-missing

override_dh_makeshlibs:
	dh_makeshlibs -- -c4

override_dh_installinit:
	dh_installinit --noscripts --no-start

override_dh_auto_clean:
	dh_auto_clean
	rm -f $(MANPAGES)
	rm -f $(OUTFILES)
	rm -f data/gdm.schemas data/61-gdm.rules

override_dh_gnome_clean:

## gdm3 49~beta

=== meson_options.txt ===
option('at-spi-registryd-dir', type: 'string', value: '', description: 'Specify the directory of at-spi-registryd.')
option('custom-conf', type: 'string', value: '', description: 'Filename to give to custom configuration file.')
option('dbus-sys', type: 'string', value: '', description: 'Where D-Bus systemd directory is.')
option('default-pam-config', type: 'combo', choices: [ 'autodetect', 'redhat', 'openembedded', 'exherbo', 'lfs', 'arch', 'none'], value: 'autodetect', description: '')
option('default-path', type: 'string', value: '/usr/local/bin:/usr/local/sbin:/usr/bin:/usr/sbin:/bin:/sbin', description: 'Path GDM will use as the user\'s default PATH.')
option('defaults-conf', type: 'string', value: '', description: 'Filename to give to defaults file.')
option('distro', type: 'string', value: 'none', description: 'Distribution name, used to detect PAM files and hook scripts.')
option('dmconfdir', type: 'string', value: '', description: 'Directory where sessions are stored.')
option('gdm-xsession', type: 'boolean', value: false, description: 'Enable installing the gdm Xsession file.')
option('gnome-settings-daemon-dir', type: 'string', value: '', description: 'Specify the directory of gnome-settings-daemon used by the chooser.')
option('group', type: 'string', value: 'gdm', description: 'GDM\'s group.')
option('initial-vt', type: 'integer', value: 1, description: 'Initial virtual terminal to use.')
option('ipv6', type: 'boolean', value: false, description: 'Enables compilation of IPv6 code.')
option('lang-file', type: 'string', value: '', description: 'File containing default language settings.')
option('libaudit', type: 'feature', value: 'auto', description: 'Add Linux audit support.')
option('logind-provider', type: 'combo', choices: ['systemd', 'elogind'], value: 'systemd', description: 'Which logind library to use.')
option('log-dir', type: 'string', value: '/var/log/gdm', description: 'Log directory.')
option('pam-mod-dir', type: 'string', value: '', description: 'Directory to install PAM modules in.')
option('pam-prefix', type: 'string', value: '', description: 'Specify where PAM files go.')
option('pid-file', type: 'string', value: '', description: 'Pid file.')
option('plymouth', type: 'feature', value: 'auto', description: 'Add plymouth support.')
option('private-dbus-dir', type: 'string', value: '', description: 'Directory for private D-Bus server sockets')
option('profiling', type: 'boolean', value: false, description: 'Enable profiling.')
option('run-dir', type: 'string', value: '', description: 'Runtime directory.')
option('runtime-conf', type: 'string', value: '', description: 'Filename to give to runtime configuration file.')
option('selinux', type: 'feature', value: 'auto', description: 'Add SELinux support.')
option('solaris', type: 'boolean', value: false, description: 'Build for Solaris')
option('split-authentication', type: 'boolean', value: true, description: 'Enable multiple simultaneous PAM conversations during login.')
option('sysconfsubdir', type: 'string', value: 'gdm', description: 'Directory name used under sysconfdir.')
option('systemd-journal', type: 'boolean', value: true, description: 'Use journald support.')
option('systemdsystemunitdir', type: 'string', value: '', description: 'Directory for systemd service files, or \'no\' to disable.')
option('systemduserunitdir', type: 'string', value: '', description: 'Directory for systemd user service files, or \'no\' to disable.')
option('tcp-wrappers', type: 'boolean', value: false, description: 'Use TCP wrappers.')
option('udev-dir', type: 'string', value: '', description: 'Directory for udev rules file.')
option('user', type: 'string', value: 'gdm', description: 'GDM\'s username.')
option('user-display-server', type: 'boolean', value: true, description: 'Enable running X server as user.')
option('wayland-support', type: 'boolean', value: true, description: 'Enable support for wayland sessions.')
option('x11-support', type: 'boolean', value: false, description: 'Enable support for x11 sessions.')
option('xauth-dir', type: 'string', value: '', description: 'XAuth cookie directory.')
option('xdmcp', type: 'feature', value: 'auto', description: 'Add XDMCP (remote login) support.')
option('dyn-home-dir', type: 'string', value: '', description: 'Parent directory for dynamic user home directories')

=== debian/changelog ===
gdm3 (49~beta-0ubuntu2) questing; urgency=medium

  * Merge with Debian. Remaining changes:
    + readme.debian: update for correct paths in ubuntu
    + control:
      - don't recommend desktop-base
      - depend on bash for config_error_dialog.patch
      - update vcs field
    + rules:
      - don't override default user/group
      - -dgdm-xsession=true to install upstream xsession script
      - override dh_installinit with --no-start to avoid session being killed
    + rules, readme.debian, gdm3.8.pod:
      use upstream custom.conf instead of daemon.conf
    + gdm3.sysusers: rename user and group back to gdm
    + debian/tests/control:
      - Use gdm user name
    + gdm3.*.pam: make pam_env read ~/.pam_environment, as we use in g-c-c
      settings
    + gdm3.install:
      - don't install debian/xsession
    + add run_xsession.d.patch
    + add xresources_is_a_dir.patch
      - fix loading from /etc/x11/xresources/*
    + add nvidia_prime.patch:
      - add hook to run prime-offload (as root) and prime-switch if
        nvidia-prime is installed
    + add revert_override_lang_with_accountservices.patch:
      - on ubuntu accountservices only stores the language and not the
        full locale as needed by lang.
    + add dont_set_language_env.patch:
      - don't run the set_up_session_language() function, since it
        overrides variable values set by ~/.pam_environment
    + add config_error_dialog.patch:
      - show warning dialog in case of error in ~/.profile etc. and
        don't let a syntax error make the login fail
    + add prefer_ubuntu_session_fallback.patch:
      - Prefer ubuntu session as fallback instead of GNOME
    + add XSession-Use-x-terminal-emulator-as-fallback-instead-of-x.patch:
      - Use x-terminal-emulator as fallback instead of xterm
    + debian/greeter.dconf-defaults: don't set debian settings in the
      greeter's dconf db
    + debian/greeter.dconf-defaults: keep smartcard auth enabled by default
    + New upstream release 49~beta
      - d/control: Drop dependency on dbus-daemon
      - d/control: Require gnome-session 49~beta
      - d/rules: Drop meson options working-dir, screenshot-dir,
        ran-once-marker-dir
    + Disable x11 greeter
      - d/rules: Disable x11-support flag
      - d/control: Drop unused build-deps
      - d/control: Drop long unused dependency on Xephyr
      - d/control: Drop dependency on Xorg

 -- Alessandro Astone <alessandro.astone@canonical.com>  Mon, 18 Aug 2025 21:10:23 +0200

gdm3 (48.0-3) unstable; urgency=medium

  * Team upload

  [ Luca Boccassi ]
  * Use a sysusers.d file to create the Debian-gdm user.
    This allows /usr-only images with an ephemeral/factory reset/firstboot
    /etc/. (Closes: #1107682)

  [ Simon McVittie ]
  * Activate dh_installsysusers declaratively rather than imperatively.
    This lets debhelper choose a good point in the sequence for it.
  * d/gdm3.postrm, d/control: Don't delete system user/group during purge.
    In previous discussions like #1006912 there seems to be consensus
    that removing uids is dangerous because there might still be files
    owned by that uid on the filesystem, causing unintended access to be
    granted if the uid is subsequently reused for a different system user.
    This also means we can drop the adduser dependency.
  * Build-depend on gir1.2-*-dev instead of libgirepository1.0-dev.
    libgirepository1.0-dev is not Multi-Arch co-installable and should be
    phased out during the forky release cycle.
  * d/control, d/rules: Let the package be cross-compiled.
    debhelper currently uses debcrossgen which does not support cross
    GObject-Introspection, so for now we need to opt-in to using
    `meson env2mfile` instead.
    We need to run dconf-cli from the build architecture, since we will
    be unable to run it from the host architecture in general.
  * d/copyright: Don't quote the FSF's former postal address
  * Standards-Version: 4.7.2 (no changes required)

 -- Simon McVittie <smcv@debian.org>  Fri, 15 Aug 2025 10:53:47 +0100

gdm3 (49~beta-0ubuntu1) questing; urgency=medium

  * New upstream release
    - The greeter no longer runs under the gdm user; instead it uses a
      temporary user dynamically allocated at runtime
    - /var/lib/gdm3 is now only used for the greeter-dconf-defaults
  * d/control: Drop dependency on dbus-daemon
  * d/control: Require gnome-session 49~beta
  * d/patches: Refresh patches
  * d/rules: Drop meson options working-dir, screenshot-dir, ran-once-marker-dir
  * d/libgdm1.symbols: Add new symbols
  * d/default.pa: Drop obsolete pulseaudio workaround

 -- Alessandro Astone <alessandro.astone@canonical.com>  Tue, 05 Aug 2025 14:37:42 +0200

gdm3 (49~alpha.1-0ubuntu2) questing; urgency=medium

  * d/control: Drop long unused dependency on Xephyr
  * d/control: Drop dependency on Xorg

 -- Alessandro Astone <alessandro.astone@canonical.com>  Mon, 04 Aug 2025 14:26:18 +0200

=== debian/control ===
--- 
+++ 
@@ -5,23 +5,26 @@
 XSBC-Original-Maintainer: Debian GNOME Maintainers <pkg-gnome-maintainers@lists.alioth.debian.org>
 Uploaders: Jeremy Bicha <jbicha@ubuntu.com>, Marco Trevisan (Treviño) <marco@ubuntu.com>
 Build-Depends: check (>= 0.9.4),
-               dconf-cli (>= 0.19.90),
+               dconf-cli:native (>= 0.19.90),
                debhelper-compat (= 13),
                dh-exec,
                dh-sequence-gir,
                dh-sequence-gnome,
+               dh-sequence-installsysusers,
                docbook-xml,
                gettext (>= 0.19.8),
+               gir1.2-gio-2.0-dev,
+               gir1.2-glib-2.0-dev,
+               gir1.2-gobject-2.0-dev,
                gjs [amd64 arm64 armhf i386 loong64 mips64el mipsel ppc64el s390x riscv64],
                gnome-pkg-tools (>= 0.16.3),
                gnome-settings-daemon-dev (>= 3.24.0),
-               gobject-introspection (>= 0.10.7-1~),
+               gobject-introspection (>= 1.80),
                intltool,
                iso-codes,
                itstool,
                libaccountsservice-dev (>= 0.6.35),
                libaudit-dev [linux-any],
-               libgirepository1.0-dev (>= 0.9.12),
                libglib2.0-dev (>= 2.44.0),
                libgudev-1.0-dev (>= 232),
                libjson-glib-dev,
@@ -33,7 +36,7 @@
                meson (>= 0.57),
                pkgconf,
                systemd-dev,
-Standards-Version: 4.7.0
+Standards-Version: 4.7.2
 XS-Debian-Vcs-Git: https://salsa.debian.org/gnome-team/gdm.git
 XS-Debian-Vcs-Browser: https://salsa.debian.org/gnome-team/gdm
 Vcs-Git: https://salsa.debian.org/gnome-team/gdm.git -b ubuntu/latest
@@ -44,18 +47,16 @@
 Package: gdm3
 Architecture: amd64 arm64 armhf i386 loong64 mips64el mipsel ppc64el s390x riscv64
 Depends: accountsservice (>= 0.6.35),
-         adduser,
          bash (>= 4.3),
          dconf-cli (>= 0.20),
          dconf-gsettings-backend (>= 0.20),
          dbus-bin | systemd-sysv,
-         dbus-daemon,
          default-dbus-system-bus | dbus-system-bus,
          default-logind [linux-any] | logind [linux-any],
          gir1.2-gdm-1.0 (= ${binary:Version}),
          ubuntu-session | gnome-session | x-session-manager | x-window-manager | x-terminal-emulator,
-         gnome-session-bin (>= 3.37.0),
-         gnome-session-common (>= 3.37.0-2~),
+         gnome-session-bin (>= 49~beta),
+         gnome-session-common (>= 49~beta),
          gnome-settings-daemon (>= 3.37.0),
          gnome-shell (>= 3.37.90),
          gsettings-desktop-schemas,
@@ -74,8 +75,6 @@
 Recommends: at-spi2-core,
             ubuntu-session | gnome-session | x-session-manager,
             x11-xkb-utils,
-            xserver-xephyr,
-            xserver-xorg,
             zenity
 Suggests: orca,
           libpam-fprintd (>= 0.8.0-2),

=== debian/rules ===
--- 
+++ 
@@ -12,6 +12,9 @@
 
 export DEB_BUILD_MAINT_OPTIONS = hardening=+all
 export DEB_LDFLAGS_MAINT_APPEND = -Wl,-z,defs
+
+# https://bugs.debian.org/1060838, https://bugs.debian.org/1111001
+export MESON_USE_NEW_CROSSGEN=1
 
 ifeq (linux,$(DEB_HOST_ARCH_OS))
 CONFFLAGS += \
@@ -49,17 +52,14 @@
 		-Dat-spi-registryd-dir=/usr/lib/at-spi \
 		-Ddefault-path=/usr/local/bin:/usr/bin:/bin:/usr/games \
 		-Dsysconfsubdir=gdm3 \
-		-Dworking-dir=/var/lib/gdm3 \
 		-Dxauth-dir=/run/gdm3 \
 		-Drun-dir=/run/gdm3 \
 		-Dpid-file=/run/gdm3.pid \
 		-Dlog-dir=/var/log/gdm3 \
 		-Dgdm-xsession=true \
 		-Dpam-mod-dir=/usr/lib/$(DEB_HOST_MULTIARCH)/security \
-		-Dscreenshot-dir=/run/gdm3/greeter \
 		-Ddefaults-conf=/usr/share/gdm/defaults.conf \
 		-Dlang-file=/etc/default/locale \
-		-Dran-once-marker-dir=/run/gdm3 \
 		-Dgnome-settings-daemon-dir="`pkg-config --variable=libexecdir gnome-settings-daemon`" \
 		-Dx11-support=false \
 		$(CONFFLAGS)

## gdm3 49~rc

=== debian/changelog ===
gdm3 (49~rc-0ubuntu2) questing; urgency=medium

  * Never use Xorg for the greeter (LP: #2122294)

 -- Alessandro Astone <alessandro.astone@canonical.com>  Tue, 09 Sep 2025 17:31:45 +0200

gdm3 (49~rc-0ubuntu1) questing; urgency=medium

  * New upstream release:
    - Fix greeter starting before a GPU driver has loaded (LP: #2115451)
  * debian: Restore support for logging into X11 sessions
    - This also restores support for running the greeter in X11 mode,
      because the two couldn't be decoupled in time for GNOME 49.
  * d/rules: Restore working-dir meson option
  * d/p: Refresh patches

 -- Alessandro Astone <alessandro.astone@canonical.com>  Thu, 04 Sep 2025 12:00:40 +0200

gdm3 (49~beta-0ubuntu3) questing; urgency=medium

  * Make gdm3 depend on libnss-systemd (LP: #2121017)

 -- Daniel van Vugt <daniel.van.vugt@canonical.com>  Mon, 01 Sep 2025 17:19:47 +0800

=== debian/rules ===
--- 
+++ 
@@ -52,6 +52,7 @@
 		-Dat-spi-registryd-dir=/usr/lib/at-spi \
 		-Ddefault-path=/usr/local/bin:/usr/bin:/bin:/usr/games \
 		-Dsysconfsubdir=gdm3 \
+		-Dworking-dir=/var/lib/gdm3 \
 		-Dxauth-dir=/run/gdm3 \
 		-Drun-dir=/run/gdm3 \
 		-Dpid-file=/run/gdm3.pid \
@@ -61,7 +62,7 @@
 		-Ddefaults-conf=/usr/share/gdm/defaults.conf \
 		-Dlang-file=/etc/default/locale \
 		-Dgnome-settings-daemon-dir="`pkg-config --variable=libexecdir gnome-settings-daemon`" \
-		-Dx11-support=false \
+		-Dx11-support=true \
 		$(CONFFLAGS)
 
 override_dh_auto_build: $(OUTFILES) $(MANPAGES)

## gdm3 49.0.1

=== debian/changelog ===
gdm3 (49.0.1-1ubuntu2) questing; urgency=medium

  * Add d/p/userdb-Handle-missing-UID-correctly-in-user-record-query.patch.
    Fix an issue where querying the userdb service for information on uid 0
    would incorrectly return the information for one of the gdm dynamic users.
    This confused logind/polkit causing permission errors in a gdm-greeter or
    gnome-initial-setup session (LP: #2122340).

 -- Alessandro Astone <alessandro.astone@canonical.com>  Fri, 26 Sep 2025 09:59:24 +0200

gdm3 (49.0.1-1ubuntu1) questing; urgency=medium

  * Merge with debian for new bugfix release (LP: #2125340)
    Remaining changes:
    + readme.debian: update for correct paths in ubuntu
    + control:
      - don't recommend desktop-base
      - depend on bash for config_error_dialog.patch
      - update vcs field
    + rules:
      - don't override default user/group
      - -dgdm-xsession=true to install upstream xsession script
      - override dh_installinit with --no-start to avoid session being killed
    + rules, readme.debian, gdm3.8.pod:
      use upstream custom.conf instead of daemon.conf
    + gdm3.sysusers: rename user and group back to gdm
    + debian/tests/control:
      - Use gdm user name
    + gdm3.*.pam: make pam_env read ~/.pam_environment, as we use in g-c-c
      settings
    + add run_xsession.d.patch
    + add xresources_is_a_dir.patch
      - fix loading from /etc/x11/xresources/*
    + add nvidia_prime.patch:
      - add hook to run prime-offload (as root) and prime-switch if
        nvidia-prime is installed
    + add revert_override_lang_with_accountservices.patch:
      - on ubuntu accountservices only stores the language and not the
        full locale as needed by lang.
    + add dont_set_language_env.patch:
      - don't run the set_up_session_language() function, since it
        overrides variable values set by ~/.pam_environment
    + add config_error_dialog.patch:
      - show warning dialog in case of error in ~/.profile etc. and
        don't let a syntax error make the login fail
    + add prefer_ubuntu_session_fallback.patch:
      - Prefer ubuntu session as fallback instead of GNOME
    + add XSession-Use-x-terminal-emulator-as-fallback-instead-of-x.patch:
      - Use x-terminal-emulator as fallback instead of xterm
    + debian/greeter.dconf-defaults: don't set debian settings in the
      greeter's dconf db
    + debian/greeter.dconf-defaults: keep smartcard auth enabled by default
    + Disable x11 greeter
      - add d/p/Never-use-Xorg-for-the-greeter.patch
      - d/control: Drop long unused dependency on Xephyr
      - d/control: Drop dependency on Xorg
  * Add systemd drop-in to skip snapd.session-agent in the greeter session
    (LP: #2125133)

 -- Alessandro Astone <alessandro.astone@canonical.com>  Mon, 22 Sep 2025 11:16:31 +0200

gdm3 (49.0.1-1) experimental; urgency=medium

  [ Jeremy Bícha ]
  * New upstream release
  * udev rules are no longer installed
  * Completely stop providing Debian custom xsession support

  [ Alessandro Astone ]
  * d/libgdm1.symbols: Add new symbols
  * d/rules: Remove obsolete meson options screenshot-dir, ran-once-marker-dir
  * Remove gcc 15 patch: applied in new release

  [ Daniel van Vugt ]
  * Make gdm3 depend on libnss-systemd (LP: #2121017)

 -- Jeremy Bícha <jbicha@ubuntu.com>  Tue, 16 Sep 2025 20:47:25 -0400

=== debian/control ===
--- 
+++ 
@@ -26,6 +26,7 @@
                libaccountsservice-dev (>= 0.6.35),
                libaudit-dev [linux-any],
                libglib2.0-dev (>= 2.44.0),
+               libgtk-3-dev (>= 2.91.1),
                libgudev-1.0-dev (>= 232),
                libjson-glib-dev,
                libkeyutils-dev [linux-any],
@@ -33,6 +34,11 @@
                libplymouth-dev [linux-any],
                libselinux1-dev [linux-any],
                libsystemd-dev [linux-any],
+               libwrap0-dev,
+               libx11-dev,
+               libxau-dev,
+               libxcb1-dev,
+               libxdmcp-dev,
                meson (>= 0.57),
                pkgconf,
                systemd-dev,
@@ -62,6 +68,7 @@
          gsettings-desktop-schemas,
          libgdm1 (= ${binary:Version}),
          libglib2.0-bin (>= 2.35.0),
+         libnss-systemd,
          libpam-modules (>= 0.72-1),
          libpam-runtime (>= 0.76-13.1),
          librsvg2-common,

=== debian/rules ===
--- 
+++ 
@@ -72,7 +72,6 @@
 	dh_install
 ifneq ($(filter gdm3,$(built_binaries)),)
 	mv debian/gdm3/usr/sbin/gdm debian/gdm3/usr/sbin/gdm3
-#	chmod 755 debian/gdm3/etc/gdm3/Xsession
 	chmod 755 debian/gdm3/usr/share/gdm/generate-config
 	dh_installpam -pgdm3 --name=gdm-autologin
 	dh_installpam -pgdm3 --name=gdm-launch-environment

=== debian/watch ===
version=4
opts="searchmode=plain, uversionmangle=s/\.(alpha|beta|rc)/~$1/, downloadurlmangle=s|cache.json||" \
https://download.gnome.org/sources/gdm/cache.json \
	[\d.]+/gdm-([\d.]+\.?(?:alpha|beta|rc)?[\d.]*)@ARCHIVE_EXT@

## gdm3 49.1

=== meson_options.txt ===
--- 
+++ 
@@ -35,7 +35,8 @@
 option('user', type: 'string', value: 'gdm', description: 'GDM\'s username.')
 option('user-display-server', type: 'boolean', value: true, description: 'Enable running X server as user.')
 option('wayland-support', type: 'boolean', value: true, description: 'Enable support for wayland sessions.')
-option('x11-support', type: 'boolean', value: false, description: 'Enable support for x11 sessions.')
+option('x11-support', type: 'boolean', value: true, description: 'Enable support for x11 sessions.')
+option('working-dir', type: 'string', value: '', description: 'Working directory.')
 option('xauth-dir', type: 'string', value: '', description: 'XAuth cookie directory.')
 option('xdmcp', type: 'feature', value: 'auto', description: 'Add XDMCP (remote login) support.')
 option('dyn-home-dir', type: 'string', value: '', description: 'Parent directory for dynamic user home directories')

=== debian/changelog ===
gdm3 (49.1-6ubuntu1) resolute; urgency=medium

  * Merge with debian. Remaining changes:
    + readme.debian: update for correct paths in ubuntu
    + control:
      - don't recommend desktop-base
      - depend on bash for config_error_dialog.patch
      - update vcs field
    + rules:
      - don't override default user/group
      - -dgdm-xsession=true to install upstream xsession script
      - override dh_installinit with --no-start to avoid session being killed
    + rules, readme.debian, gdm3.8.pod:
      use upstream custom.conf instead of daemon.conf
    + gdm3.sysusers: rename user and group back to gdm
    + debian/tests/control:
      - Use gdm user name
    + gdm3.*.pam: make pam_env read ~/.pam_environment, as we use in g-c-c
      settings
    + add run_xsession.d.patch
    + add xresources_is_a_dir.patch
      - fix loading from /etc/x11/xresources/*
    + add nvidia_prime.patch:
      - add hook to run prime-offload (as root) and prime-switch if
        nvidia-prime is installed
    + add revert_override_lang_with_accountservices.patch:
      - on ubuntu accountservices only stores the language and not the
        full locale as needed by lang.
    + add dont_set_language_env.patch:
      - don't run the set_up_session_language() function, since it
        overrides variable values set by ~/.pam_environment
    + add config_error_dialog.patch:
      - show warning dialog in case of error in ~/.profile etc. and
        don't let a syntax error make the login fail
    + add prefer_ubuntu_session_fallback.patch:
      - Prefer ubuntu session as fallback instead of GNOME
    + add XSession-Use-x-terminal-emulator-as-fallback-instead-of-x.patch:
      - Use x-terminal-emulator as fallback instead of xterm
    + debian/greeter.dconf-defaults:
      - don't set debian settings in the greeter's dconf db
      - keep smartcard auth enabled by default
    + Disable x11 greeter
      - add d/p/Never-use-Xorg-for-the-greeter.patch
      - d/control: Drop long unused dependency on Xephyr
      - d/control: Drop dependency on Xorg
    + Add systemd drop-in to skip snapd.session-agent in the greeter session
      (LP: 2125133)
    + d/control: Drop unused dependency on dbus-daemon

 -- Alessandro Astone <alessandro.astone@canonical.com>  Fri, 07 Nov 2025 10:16:20 +0100

gdm3 (49.1-6) unstable; urgency=medium

  * Team upload
  * d/Xsession, d/gdm3.install, d/rules:
    Restore ability to launch X11 sessions.
    Version 49.0.1-1 removed the example of a non-package-manager-provided
    X11 session, but also removed the ability to launch X11 sessions
    at all: all sessions that do not have X-GDM-BypassXsession
    in their .desktop file require an Xsession script, which was
    historically provided by Debian rather than by upstream. Restore
    that functionality.
    In a future upload we should look at whether we can use
    /etc/X11/Xsession as-is, but let's get the GNOME 49 transition
    done first.

 -- Simon McVittie <smcv@debian.org>  Fri, 31 Oct 2025 19:13:51 +0000

gdm3 (49.1-5) unstable; urgency=medium

  * Team upload
  * d/control: Increase gnome-session-{bin,common} dependency to 49.
    The new version of gdm doesn't start successfully with the old
    gnome-session. The new gnome-session-bin already Breaks the older
    gdm3, but the new gdm3 didn't yet force installation of the new
    gnome-session. (Closes: #1119809)

 -- Simon McVittie <smcv@debian.org>  Fri, 31 Oct 2025 18:12:04 +0000

gdm3 (49.1-4) unstable; urgency=medium

  * Team upload
  * Release to unstable (transition: #1116394)

 -- Simon McVittie <smcv@debian.org>  Fri, 31 Oct 2025 10:49:43 +0000

gdm3 (49.1-3) experimental; urgency=medium

  * Team upload
  * d/control: Remove :native annotation from dconf-cli.
    Now that dconf-cli is Multi-Arch: foreign, this is unsatisfiable.

 -- Simon McVittie <smcv@debian.org>  Mon, 27 Oct 2025 16:51:20 +0000

gdm3 (49.1-2) experimental; urgency=medium

  * Team upload
  * d/control: Depend on a version of libnss-systemd with #1118640 fixed.
    Otherwise, looking up the gdm-greeter* dynamic users in shadow/gshadow
    will not work on systems that were installed as Debian 11 or older,
    and then upgraded. (Closes: #1116563, #1118454) (LP: #2121017)
  * d/greeter.dconf-defaults: Improve documentation a bit
  * d/greeter.dconf-defaults: Mention the accent colour option.
    When we reach the forky freeze and background/branding images become
    available in desktop-base, we might want to set this to a coordinating
    colour (see #1105056). Until then, leave the default commented-out.

 -- Simon McVittie <smcv@debian.org>  Mon, 27 Oct 2025 15:18:06 +0000

gdm3 (49.1-1) experimental; urgency=medium

  * Team upload

  [ Simon McVittie ]
  * New upstream bugfix release

  [ Luca Boccassi ]
  * Do not patch out display-manager.service alias from .service file
    (Closes: #1025349)

 -- Simon McVittie <smcv@debian.org>  Tue, 14 Oct 2025 10:28:41 +0100

=== debian/control ===
--- 
+++ 
@@ -5,7 +5,7 @@
 XSBC-Original-Maintainer: Debian GNOME Maintainers <pkg-gnome-maintainers@lists.alioth.debian.org>
 Uploaders: Jeremy Bicha <jbicha@ubuntu.com>, Marco Trevisan (Treviño) <marco@ubuntu.com>
 Build-Depends: check (>= 0.9.4),
-               dconf-cli:native (>= 0.19.90),
+               dconf-cli (>= 0.19.90),
                debhelper-compat (= 13),
                dh-exec,
                dh-sequence-gir,
@@ -61,14 +61,14 @@
          default-logind [linux-any] | logind [linux-any],
          gir1.2-gdm-1.0 (= ${binary:Version}),
          ubuntu-session | gnome-session | x-session-manager | x-window-manager | x-terminal-emulator,
-         gnome-session-bin (>= 49~beta),
-         gnome-session-common (>= 49~beta),
+         gnome-session-bin (>= 49),
+         gnome-session-common (>= 49),
          gnome-settings-daemon (>= 3.37.0),
          gnome-shell (>= 3.37.90),
          gsettings-desktop-schemas,
          libgdm1 (= ${binary:Version}),
          libglib2.0-bin (>= 2.35.0),
-         libnss-systemd,
+         libnss-systemd (>= 258.1-2~),
          libpam-modules (>= 0.72-1),
          libpam-runtime (>= 0.76-13.1),
          librsvg2-common,

=== debian/rules ===
--- 
+++ 
@@ -72,6 +72,7 @@
 	dh_install
 ifneq ($(filter gdm3,$(built_binaries)),)
 	mv debian/gdm3/usr/sbin/gdm debian/gdm3/usr/sbin/gdm3
+	chmod 755 debian/gdm3/etc/gdm3/Xsession
 	chmod 755 debian/gdm3/usr/share/gdm/generate-config
 	dh_installpam -pgdm3 --name=gdm-autologin
 	dh_installpam -pgdm3 --name=gdm-launch-environment

=== debian/tests/control ===
Test-Command: sudo env
  OFFLINE_MODE=1
  GDM_USER=gdm
  bash debian/tests/sssd-gdm-smartcard-pam-auth-tester.sh
Features: test-name=sssd-gdm-smartcard-auth-test
Classes: desktop
Architecture: !armel
Depends: bash,
         gdm3,
         gnutls-bin,
         libpam-sss,
         openssl,
         pamtester,
         passwd,
         softhsm2,
         sssd,
         util-linux
Restrictions: breaks-testbed,
              isolation-container,
              needs-sudo,
              allow-stderr

## gdm3 49.2

=== debian/changelog ===
gdm3 (49.2-4) unstable; urgency=medium

  [ Jonas Jelten ]
  * d/t/sssd-gdm-smartcard-pam-auth-tester: remove sssd implicit files domain
    (Closes: #1126368) (LP: #2130705)

  [ Jeremy Bícha ]
  * Branch for forky

 -- Jeremy Bícha <jbicha@ubuntu.com>  Wed, 18 Feb 2026 09:51:40 -0500

gdm3 (49.2-3) unstable; urgency=medium

  [ Alessandro Astone ]
  * d/tests: Add autopkgtest verifying that the greeter registers

  [ Jeremy Bícha ]
  * Remove Recommends: xserver-xorg
  * Bump Standards Version to 4.7.3

 -- Jeremy Bícha <jbicha@ubuntu.com>  Sun, 28 Dec 2025 09:29:21 -0500

gdm3 (49.2-2) unstable; urgency=medium

  [ Alessandro Astone ]
  * d/control: Remove obsolete dependency on dbus-daemon

  [ Jeremy Bícha ]
  * Remove support for DEB_BUILD_OPTIONS=debug

 -- Jeremy Bícha <jbicha@ubuntu.com>  Wed, 03 Dec 2025 22:34:05 -0500

gdm3 (49.2-1) unstable; urgency=medium

  * New upstream release
  * Disable xdmcp; this feature is being removed for GNOME 50 anyway
  * Remove obsolete Conflicts/Replaces
  * Remove obsolete Recommends: xserver-xephyr (Closes: #792220)
  * Remove obsolete details from README.Debian
  * Add patch to support Debian's Xsession.options.d
  * Add patch from Ubuntu to have Xsession run scripts from /etc/X11/Xsession.d
  * Add patch from Ubuntu to use x-terminal-emulator instead of xterm
  * Add patch from Ubuntu to handle /etc/X11/Xresources/*
  * Fix what appears to be a mistake in the Xresources patch description
  * Use upstream's Xsession file (with some patching as mentioned above)
    (Closes: #1120328)

 -- Jeremy Bícha <jbicha@ubuntu.com>  Mon, 24 Nov 2025 19:38:50 -0500

=== debian/control ===
--- 
+++ 
@@ -1,9 +1,7 @@
 Source: gdm3
 Section: gnome
-Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Debian GNOME Maintainers <pkg-gnome-maintainers@lists.alioth.debian.org>
-Uploaders: Jeremy Bicha <jbicha@ubuntu.com>, Marco Trevisan (Treviño) <marco@ubuntu.com>
+Maintainer: Debian GNOME Maintainers <pkg-gnome-maintainers@lists.alioth.debian.org>
+Uploaders: Jeremy Bícha <jbicha@ubuntu.com>, Laurent Bigonville <bigon@debian.org>, Marco Trevisan (Treviño) <marco@ubuntu.com>
 Build-Depends: check (>= 0.9.4),
                dconf-cli (>= 0.19.90),
                debhelper-compat (= 13),
@@ -16,8 +14,7 @@
                gir1.2-gio-2.0-dev,
                gir1.2-glib-2.0-dev,
                gir1.2-gobject-2.0-dev,
-               gjs [amd64 arm64 armhf i386 loong64 mips64el mipsel ppc64el s390x riscv64],
-               gnome-pkg-tools (>= 0.16.3),
+               gjs [amd64 arm64 armhf i386 loong64 ppc64el riscv64 s390x],
                gnome-settings-daemon-dev (>= 3.24.0),
                gobject-introspection (>= 1.80),
                intltool,
@@ -42,25 +39,21 @@
                meson (>= 0.57),
                pkgconf,
                systemd-dev,
-Standards-Version: 4.7.2
-XS-Debian-Vcs-Git: https://salsa.debian.org/gnome-team/gdm.git
-XS-Debian-Vcs-Browser: https://salsa.debian.org/gnome-team/gdm
-Vcs-Git: https://salsa.debian.org/gnome-team/gdm.git -b ubuntu/latest
-Vcs-Browser: https://salsa.debian.org/gnome-team/gdm/tree/ubuntu/latest
-Rules-Requires-Root: no
+Standards-Version: 4.7.3
+Vcs-Browser: https://salsa.debian.org/gnome-team/gdm
+Vcs-Git: https://salsa.debian.org/gnome-team/gdm.git
 Homepage: https://wiki.gnome.org/Projects/GDM/
 
 Package: gdm3
-Architecture: amd64 arm64 armhf i386 loong64 mips64el mipsel ppc64el s390x riscv64
+Architecture: amd64 arm64 armhf i386 loong64 ppc64el riscv64 s390x
 Depends: accountsservice (>= 0.6.35),
-         bash (>= 4.3),
          dconf-cli (>= 0.20),
          dconf-gsettings-backend (>= 0.20),
          dbus-bin | systemd-sysv,
          default-dbus-system-bus | dbus-system-bus,
          default-logind [linux-any] | logind [linux-any],
          gir1.2-gdm-1.0 (= ${binary:Version}),
-         ubuntu-session | gnome-session | x-session-manager | x-window-manager | x-terminal-emulator,
+         gnome-session | x-session-manager | x-window-manager | x-terminal-emulator,
          gnome-session-bin (>= 49),
          gnome-session-common (>= 49),
          gnome-settings-daemon (>= 3.37.0),
@@ -80,7 +73,8 @@
          ${misc:Depends},
          ${shlibs:Depends}
 Recommends: at-spi2-core,
-            ubuntu-session | gnome-session | x-session-manager,
+            desktop-base (>= 10.0.0),
+            gnome-session | x-session-manager,
             x11-xkb-utils,
             zenity
 Suggests: orca,
@@ -122,8 +116,7 @@
          libgdm1 (= ${binary:Version}),
          libglib2.0-dev (>= 2.44.0),
          ${gir:Depends},
-         ${misc:Depends},
-         ${shlibs:Depends}
+         ${misc:Depends}
 Provides: ${gir:Provides}
 Description: GNOME Display Manager (development files)
  GDM provides the equivalent of a "login:" prompt for X displays: it
@@ -140,10 +133,7 @@
 Section: introspection
 Architecture: linux-any
 Depends: ${gir:Depends},
-         ${misc:Depends},
-         ${shlibs:Depends}
-Conflicts: gir1.2-gdm3
-Replaces: gir1.2-gdm3
+         ${misc:Depends}
 Description: GObject introspection data for the GNOME Display Manager
  GDM provides the equivalent of a "login:" prompt for X displays: it
  asks for a login and starts graphical sessions.

=== debian/rules ===
--- 
+++ 
@@ -12,6 +12,7 @@
 
 export DEB_BUILD_MAINT_OPTIONS = hardening=+all
 export DEB_LDFLAGS_MAINT_APPEND = -Wl,-z,defs
+export DPKG_GENSYMBOLS_CHECK_LEVEL = 4
 
 # https://bugs.debian.org/1060838, https://bugs.debian.org/1111001
 export MESON_USE_NEW_CROSSGEN=1
@@ -24,10 +25,6 @@
 CONFFLAGS += \
 	-Dwayland-support=false \
 	-Dselinux=disabled
-endif
-
-ifneq (,$(filter debug,$(DEB_BUILD_OPTIONS)))
-CONFFLAGS += --buildtype=debug
 endif
 
 pod2man := pod2man --release="GNOME $(DEB_GNOME_VERSION)" --center="Debian GNU/Linux"
@@ -51,15 +48,18 @@
 		-Dipv6=true \
 		-Dat-spi-registryd-dir=/usr/lib/at-spi \
 		-Ddefault-path=/usr/local/bin:/usr/bin:/bin:/usr/games \
+		-Dcustom-conf=/etc/gdm3/daemon.conf \
 		-Dsysconfsubdir=gdm3 \
 		-Dworking-dir=/var/lib/gdm3 \
 		-Dxauth-dir=/run/gdm3 \
+		-Dxdmcp=disabled \
 		-Drun-dir=/run/gdm3 \
 		-Dpid-file=/run/gdm3.pid \
 		-Dlog-dir=/var/log/gdm3 \
-		-Dgdm-xsession=true \
 		-Dpam-mod-dir=/usr/lib/$(DEB_HOST_MULTIARCH)/security \
 		-Ddefaults-conf=/usr/share/gdm/defaults.conf \
+		-Dgdm-xsession=true \
+		-Duser=Debian-gdm -Dgroup=Debian-gdm \
 		-Dlang-file=/etc/default/locale \
 		-Dgnome-settings-daemon-dir="`pkg-config --variable=libexecdir gnome-settings-daemon`" \
 		-Dx11-support=true \
@@ -68,11 +68,9 @@
 override_dh_auto_build: $(OUTFILES) $(MANPAGES)
 	dh_auto_build
 
-override_dh_install:
-	dh_install
+execute_after_dh_install:
 ifneq ($(filter gdm3,$(built_binaries)),)
 	mv debian/gdm3/usr/sbin/gdm debian/gdm3/usr/sbin/gdm3
-	chmod 755 debian/gdm3/etc/gdm3/Xsession
 	chmod 755 debian/gdm3/usr/share/gdm/generate-config
 	dh_installpam -pgdm3 --name=gdm-autologin
 	dh_installpam -pgdm3 --name=gdm-launch-environment
@@ -83,19 +81,10 @@
 	dh_installpam -pgdm3 --name=gdm-smartcard-pkcs11-exclusive
 endif
 
-override_dh_missing:
-	dh_missing --fail-missing
+override_dh_installinit:
+	dh_installinit --noscripts
 
-override_dh_makeshlibs:
-	dh_makeshlibs -- -c4
-
-override_dh_installinit:
-	dh_installinit --noscripts --no-start
-
-override_dh_auto_clean:
-	dh_auto_clean
+execute_after_dh_auto_clean:
 	rm -f $(MANPAGES)
 	rm -f $(OUTFILES)
 	rm -f data/gdm.schemas data/61-gdm.rules
-
-override_dh_gnome_clean:
